<template>
    <div class="messages">
        <transition name="fade"
                    v-for="(message, key, index) in messages"
                    :key="key"
                    @afterLeave="afterLeaveMessageElement(key)"
                    enter-active-class="animated slideInDown faster"
                    leave-active-class="animated fadeOut faster"
        >
            <message v-show="message.isShow"
                     class="message-container"
                     :key="key"
                     :ref="key + ''"
                     v-bind="{
                        id: key,
                        type: message.type,
                        title: message.title,
                        body: message.body,
                        style: {
                            left: `-${index * 100}%`,
                        },
                     }"
                     @closeMessage="closeMessageById"
            />
        </transition>
    </div>
</template>

<script>
    import Message from './Message';
    let idCounter = 0;
    export default {
        name: 'messages',

        components: {
            Message,
        },

        data() {
            return {
                messages: {

                },
            };
        },

        watch: {
            messages(newValue) {
                if(!Object.keys(newValue).length) {
                    idCounter = 0;
                }
            },
        },

        methods: {
            showMessageGetComponentExemplar(type, title, body) {
                const messagesKeys = Object.keys(this.messages);
                /*если уже существует хотя бы одно сообщение - удаление предшедствующих сообщений*/
                if(messagesKeys.length > 0) {
                    messagesKeys.forEach(messageKey => {
                        this.closeMessageById(messageKey);
                    });
                }
                const currentCounterId = `${idCounter++} ${+ new Date}`;
                const messageOptions = this.$set(this.messages, currentCounterId, {
                    type,
                    title,
                    body,
                    isShow: false,
                });
                return new Promise(resolve => {
                    this.$nextTick(() => {
                        messageOptions.isShow = true;
                        resolve(this.$refs[currentCounterId][0]);
                    });
                });
            },
            error(bodyText, titleText = 'Ошибка') {
                return this.showMessageGetComponentExemplar('error', titleText, bodyText);
            },
            success(bodyText, titleText = 'Успешно') {
                return this.showMessageGetComponentExemplar('success', titleText, bodyText);
            },
            warning(bodyText, titleText = 'Предупреждение') {
                return this.showMessageGetComponentExemplar('warning', titleText, bodyText);
            },
            closeMessageById(messageId) {
                const messageParams = this.messages[messageId];
                if(messageParams) {
                    messageParams.isShow = false;
                }
            },
            afterLeaveMessageElement(messageId) {
                if(this.messages[messageId]) {
                    delete this.$delete(this.messages, messageId);
                }
            },
            clear() {
				Object.keys(this.messages).forEach(messageKey => {
					this.closeMessageById(messageKey);
                });
            },
        },
    }
</script>

<style lang="scss" scoped>
    .messages {
        position: fixed;
        width: 100%;
        height: 100%;
        display: flex;
        padding: 0;
        visibility: hidden;
        z-index: 9999999;
    }
    .message-container {
        width: 100%;
        height: 100%;
        flex-shrink: 0;
        position: relative;
    }
</style>
